$SVNLOOK = $ARGV[0];
$REPOS = $ARGV[1];
$TXN = $ARGV[2];

sub main {
	#Get Author
	open(AUTHOR,"\"$SVNLOOK\" author -t $TXN \"$REPOS\" |");
	$Author = (<AUTHOR> =~ /(\w+\b)/)[0];
	close(AUTHOR);
	
	# Get changed files
	open(CHANGED,"\"$SVNLOOK\" changed -t $TXN \"$REPOS\" |");
	@ChangedFiles = <CHANGED>;
	close(CHANGED);
	print @ChangedFiles;

	foreach $File (@ChangedFiles){
		if($File =~ /^[UD]/){ #Only updated and deleted
			if($File !~ /(.*)\/\s*$/){ #Is not a directory
				$File = ($File =~ /....(.*)[\n\b]/)[0]; #Get just the file name
				# Get file properties
				open(PROPLIST,"\"$SVNLOOK\" proplist -t $TXN \"$REPOS\" \"$File\" |");
				$Props = join("",<PROPLIST>);
				close(PROPLIST);
				if ($Props =~ /svn:needs-lock/) { #Has svn:needs-lock
					open(LOCKDATA,"\"$SVNLOOK\" lock \"$REPOS\" \"$File\" |");
					$Lockdata = join("",<LOCKDATA>);
					close(LOCKDATA);
					if($Lockdata =~ /Owner: (\w+\b)/){
						return $1
					} else {
						print STDERR "Lock Error: There is a modified file without lock!($File)\n";
						exit 1
					}
				}
			}
		}
	}
}

main();

exit 0;
